<?php
	class OPSession{
		/**
		 * Fonction qui rcupre l'adresse IP du visiteur
		 *
		 * @return String Adresse IP 
		 */
		public static function IP(){
			if(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
			{
			  if(strchr($_SERVER['HTTP_X_FORWARDED_FOR'],','))
			  {
				 $tab=explode(',',$_SERVER['HTTP_X_FORWARDED_FOR']);
				 $realip=$tab[0];
			  }
			  else
			  {
				 $realip=$_SERVER['HTTP_X_FORWARDED_FOR'];
			  }
			}
			else{
				$realip=$_SERVER['REMOTE_ADDR'];
			}
			
			return $realip;
		}
		
		/**
		 * Gnrer une nouvelle variable de session
		 * est utilise lors de la cration ou lors d'une tentative de vol de session
		 */
		public static function NewSession(){
			//On copie la session dans une nouvelle session puis on vide cette nouvelle session
			session_regenerate_id();
			$_SESSION=array();
			
			//Dfinition de l'adresse IP en session
			$_SESSION['AGENT']    = $_SERVER['HTTP_USER_AGENT'];
			$_SESSION['LANGUAGE'] = $_SERVER['HTTP_ACCEPT_LANGUAGE'];
			$_SESSION['CHARSET']  = $_SERVER['HTTP_ACCEPT_CHARSET'];
			$_SESSION['ENCODING'] = $_SERVER['HTTP_ACCEPT_ENCODING'];
			$_SESSION['IP']       = self::IP();
		}
		
		/**
		 * Correspond  la fonction session_start() mais en version scurise
		 */
		public static function Start(){
			session_start();
			
			if(!isset($_SESSION['IP'])){
				//Si la session n'a pas t initialise
				self::NewSession();
			}else{
				//Vrificationde l'adresse IP, de l'encodage accept, des langues accepts et du navigateur
				if(
					$_SESSION['AGENT'] !== $_SERVER['HTTP_USER_AGENT']
					|| $_SESSION['LANGUAGE'] !== $_SERVER['HTTP_ACCEPT_LANGUAGE']
					|| $_SESSION['CHARSET'] !== $_SERVER['HTTP_ACCEPT_CHARSET']
					|| $_SESSION['ENCODING'] !== $_SERVER['HTTP_ACCEPT_ENCODING']
					|| $_SESSION['IP'] !== self::IP()
				){
					//Si une valeur n'est pas correcte, on crase tout et on rcrit
					self::NewSession();
				}
			}
		}
	}
?>